﻿package{
	import flash.display.MovieClip;
	import flash.geom.Point;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	import flash.events.Event;
	public class DroppedSheet extends MovieClip {
		
		//Edit the timer if needed
		private const timer = 2500; //in ms
		
		private var _game:Game;
		private var _player:Player;
		private var _startingX:uint;
		private var _startingY:uint;
		private var _sheetTimer:Timer;
		private var _ourWindow:Window;
		private var _theNanny:Nanny;
		public var hitPlayer:Hitbox;
		public var hitSill:Hitbox;
		public function DroppedSheet(value:Game, theNanny:Nanny = null){
			_game = value;
			_player = _game.getWorld.getPlayer;
			_theNanny = theNanny;
			
			if (!_game.SHOW_COLLBXS){
				hitPlayer.visible = false;
				hitSill.visible = false;
			}
			
			//Sheet partially loses power every...
			_sheetTimer = new Timer(timer);
			_sheetTimer.addEventListener(TimerEvent.TIMER, losePower, false, 0, true);
			//We'll start the timer later once more sheets are added
			
			this.addEventListener(Event.ADDED_TO_STAGE, added, false, 0, true);
		} //Constructor
		
		private function added(e:Event):void{
			this.removeEventListener(Event.ADDED_TO_STAGE, added);
			this.name = "dsheet" + _game.droppedSheetsArray.length;
			var aWindow:Window;
			//A player dropped the sheet, so set things
			if (_theNanny == null){
				aWindow = _player.hitWindow("window");
				//Tosses a sheet to the side
				if (!_game.TOSS_DIRECT){
					//The 7 below is used to center the sheet in the window
					//Facing left
					if ((_player.scaleX == -1) && (_player.hitWindow("left"))){
						this.x = aWindow.x - aWindow.width - _game.CW + 7;
					//Facing right
					}else if((_player.scaleX == 1) && (_player.hitWindow("right"))){
						this.x = aWindow.x + aWindow.width + _game.CW + 7;
					}
					this.y = _player.y - _player.height;
				}else{
					//Tosses a sheet right below the player
					this.x = aWindow.x + 7;
					this.y = _player.y - 10;
				}
				_player.sheetAmount--;
			}else{
				//A Nanny dropped it, so do things a bit differently
				aWindow = _theNanny.getParentWindow;
				this.x = aWindow.x + 7;
				this.y = aWindow.y + _theNanny.y + _theNanny.height - 5;
				_theNanny.firedSheet = this;
				_theNanny.fired = true;
			}
			_startingX = this.x;
			_startingY = this.y;
			_game.droppedSheetsArray.push(this);
			
			for (var i:uint = 0; i < _game.getWindowArray.length; i++) {
				var tempWindow:Window = _game.getWindowArray[i];
				//We're looking for the first window which a dropping
				//sheet is going to come in contact with next that is
				//still active ("false")
				
				//Mark a window if the window y is greater than the
				//starting y and it's in the same "column" as our
				//dropped sheet
				if (_theNanny == null){
					if (tempWindow.x == _startingX - 7){
						if (!tempWindow.covered){
							if (tempWindow.y > _startingY){
								if (_ourWindow == null){
										_ourWindow = tempWindow;
								}else if (tempWindow.y < _ourWindow.y){
									_ourWindow = tempWindow;
								}
							}
						}
					}
				}else{
					_ourWindow = _theNanny.getHitWindow;
				}
			}
		} //added
		
		public function get getWindow():Window {
			return _ourWindow;
		} //affectedWindow
		
		public function get getNanny():Nanny {
			return _theNanny;
		} //affectedWindow
		
		public function get checkWindColl():Boolean{
			if ((_ourWindow != null) &&
				((hitSill.hitTestObject(_ourWindow.sill)))){
				return true;
			}else{
				return false;
			}
		}
		
		private function losePower(Timer:TimerEvent):void {
			this.alpha -= 0.2;
			if (this.alpha <= 0.2) {
				_sheetTimer.stop();
				_game.removeDropped();
			}
		} //losePower
		
		public function startTimer():void{
			_sheetTimer.start();}

		public function stopTimer():void{
			_sheetTimer.stop();}
	} //DroppedSheet class
} //Package