﻿//Main.as
package{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.net.SharedObject;
	public class Main extends MovieClip{
		private var _title:TitleScn;
		private var _game:Game;
		private var _over:GameOverScn;
		private var _won:Boolean;
		private var _win:WinScn;
		private var _BW:SharedObject;
		public function Main(){
			createData();
			//Create and show the title screen
			newTitle();
			stage.stageFocusRect = false;
		} //Constructor
		
		public function createData():void {
			//Get saved data if exists
			if(!_BW){_BW = SharedObject.getLocal("BW_sheets");}
			//If a won array doesn't exist, make it
			if (!_BW.data.won){_BW.data.won = new Array();}
			_BW.flush();
		}
		
		public function loadLevel(level:String):void {
			//Get rid of the title screen
			removeTitle();			
			newGame(level);
		} //clickStart
		
		private function newGame(levelFile:String):void {
			//Create and start a new game
			_won = false;
			stage.focus = _game;
			_game = new Game(this, levelFile);
			_game.addEventListener(Event.ADDED_TO_STAGE, addKeys, false, 0, true);
			_game.addEventListener(Event.REMOVED_FROM_STAGE, remKeys, false, 0, true);
			addChild(_game);
		} //newGame
		
		public function gameOver(levelFile:String):void {
			//Get rid of the game instance
			removeChild(_game);
			_game = null;
			//Create and show the Game Over screen
			stage.focus = _over;
			_over = new GameOverScn(this, levelFile);
			addChild(_over);
		} //gameOver
		
		public function win(levelFile:String):void {
			//Get rid of the game instance
			removeChild(_game);
			_game = null;
			//Create and show the Win screen
			_won = true;
			stage.focus = _win;
			_win = new WinScn(this, levelFile);
			addChild(_win);
		} //win
		
		public function clickRestart(level:String):void {
			if (!_game){
				if (_won) {
					//Get rid of the Win screen
					removeChild(_win);
				}else{
					//Get rid of the Game Over screen
					removeChild(_over);
				}
				_over = null;
			}else {
				_game = null;
			}
			newGame(level);
		} //clickRestart
		
		public function newTitle(value:String = null):void {
			_title = new TitleScn(this, value);
			addChild(_title);
		} //newTitle
		
		public function removeTitle():void{
			removeChild(_title);
			_title = null;
		} //newTitle
		
		private function addKeys(e:Event):void {
			stage.addEventListener(KeyboardEvent.KEY_DOWN, _game.timerKeyDown, false, 0, true);
			stage.addEventListener(KeyboardEvent.KEY_UP, _game.timerKeyUp, false, 0, true);
		} //addKeys
		
		private function remKeys(e:Event):void {
			stage.removeEventListener(KeyboardEvent.KEY_DOWN, _game.timerKeyDown);
			stage.removeEventListener(KeyboardEvent.KEY_UP, _game.timerKeyUp);
		} //remKeys
		
		public function get getGame():Game{
			return _game;}
		
		public function get getBW():SharedObject{
			return _BW;}
	} //Main class
} //Package