﻿//Nanny.as
package{
	import flash.display.MovieClip;
	public class Nanny extends MovieClip {
		private var _fired:Boolean;
		private var _world:World;
		private var _ourWindow:Window;
		private var _parentWindow:Window;
		private var _windowArray:Array;
		private var _nannyArray:Array;
		private var _game:Game;
		private var _firedSheet:DroppedSheet;
		public var hit:Hitbox;
		public var nannyHit:Hitbox;
		public function Nanny(theWindow:Window = null) {
			_parentWindow = theWindow;
			if (_parentWindow){
				_world = _parentWindow.getWorld;
				_game = _world.getGame;
				_windowArray = _game.getWindowArray;
				_nannyArray = _game.nannyArray;
				if (!_game.SHOW_COLLBXS){
					this.hit.visible = false;
				}
		
			
				this.x = (_parentWindow.width / 2) - (this.width / 2);
				this.y = _parentWindow.sill.y - this.height;
				_parentWindow.addChild(this);
				this.name = String("n") + "-" +
				String((_windowArray.length - 1)) + "-" +
				_nannyArray.length;
				_nannyArray.push(this);
			}else{
				this.hit.visible = false;
			}
		} //Constructor
		
		public function findWindow():void{
			for (var i:uint = 0; i < _windowArray.length; i++) {
				var tempWindow:Window = _windowArray[i];
				//We're looking for the first window which a dropping
				//sheet is going to come in contact with next that is
				//still active ("false")
				
				//Mark a window if the window y is greater than the
				//starting y and it's in the same "column" as our
				//dropped sheet
				if (tempWindow.x == _parentWindow.x) {
					if (tempWindow.y > _parentWindow.y){
						if (_ourWindow == null){
							_ourWindow = tempWindow;
						}else if (tempWindow.y < _ourWindow.y){
							_ourWindow = tempWindow;
						}
					}
				}
			}
			if (_ourWindow != null){
				makeHitbox();
			}
		} //findWindow
		
		private function makeHitbox():void{
			nannyHit = new Hitbox();
			if (!_game.SHOW_COLLBXS){
				nannyHit.visible = false;
			}
			nannyHit.width = hit.width;
			nannyHit.height = hit.height;
			_ourWindow.addChild(nannyHit);
			nannyHit.x = (_ourWindow.width / 2) - (nannyHit.width / 2);
			nannyHit.y = _ourWindow.sill.y - nannyHit.height;
		} //makeHitbox
		
		public function get getParentWindow():Window{
			return _parentWindow;}
		
		public function get getHitWindow():Window{
			return _ourWindow;}
		
		public function set fired(value:Boolean):void {
			_fired = value;}
		
		public function get fired():Boolean{
			return _fired; }
		
		public function set firedSheet(value:DroppedSheet):void {
			_firedSheet = value;}
		
		public function get firedSheet():DroppedSheet{
			return _firedSheet;}
	} //Nanny class
} //Package