﻿package {
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.TimerEvent;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.utils.Timer;
	public class Notif extends MovieClip {
		private var _type:String;
		private var _notifTxt:TextField;
		private var _notifFmt:TextFormat;
		private var _world:World;
		private var _player:Player;
		private var _floatTimer:Timer;
		private var _dimTimer:Timer;
		public function Notif(world:World, type:*){
			_world = world;
			_player = _world.getPlayer;
			_type = String(type);
			_floatTimer = new Timer(20);
			_floatTimer.addEventListener(TimerEvent.TIMER, float, false, 0, true);
			_dimTimer = new Timer(300);
			_dimTimer.addEventListener(TimerEvent.TIMER, dim, false, 0, true);
			switch (_type){
				case "+c":
					_type = "+1 child";
					break;
				case "-c":
					_type = "1 child lost";
					break;
				default:
					_type = "+" + _type + " sheets";
					break;
			}
			this.addEventListener(Event.ADDED_TO_STAGE, added, false, 0, true);
		} //Constructor
		
		private function added(e:Event):void {
			this.removeEventListener(Event.ADDED_TO_STAGE, added);
			_notifFmt = new TextFormat();
				_notifFmt.font = "Impact";
				_notifFmt.size = 18;
				_notifFmt.color = 0xFFFFFF;
			_notifTxt = new TextField();
			_notifTxt.defaultTextFormat = _notifFmt;
			_notifTxt.width = 100;
			_notifTxt.text = _type;
			_notifTxt.selectable = false;
			addChild(_notifTxt);
			_notifTxt.x = _player.x - (this.width / 2);
			_notifTxt.y = _player.y - 35;
			_floatTimer.start();
			_dimTimer.start();
		} //added
		
		private function float(e:TimerEvent):void {this.y -= 1;}
		private function dim(e:TimerEvent):void {
			this.alpha -= 0.08;
			if (this.alpha <= 0) {
				_floatTimer.stop();
				_dimTimer.stop();
				_world.removeChild(this);
			}
		}
	} //Notif class
} //Package