﻿//Player.as
package {
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.geom.Point;
	import flash.text.TextField;
	public class Player extends MovieClip {
		
		private var _game:Game;
		private var _world:World;
		private var _sheetAmount:uint;
		private var _childAmount:uint;
		private var _ableToMove:Boolean;
		private var _dead:Boolean;
		private var _falling:Boolean;
		private const _moveAmount:uint = 1;
		private const _fallAmount:uint = 3; 
		public var hit:Hitbox;
		
		public function Player(game:Game = null, px:uint = 0, py:uint = 0, pSheets:uint = 0, pChild:uint = 0){
			_game = game;
			if (_game){
				_world = _game.getWorld;
				sheetAmount = pSheets;	//Set method
				childAmount = pChild;	//Set method
				_ableToMove = true;
				_falling = true;
				x = px;
				y = py;
				if (!_game.SHOW_COLLBXS){
					hit.visible = false;
				}
			}else{
				hit.visible = false;
			}
		}
		
		public function get sheetAmount():uint {
			return _sheetAmount;}
		
		public function set sheetAmount(value:uint):void {
			_sheetAmount = value;
			_game.ui.sheetAmount = _sheetAmount; }
		
		public function get childAmount():uint {
			return _childAmount;}
		
		public function set childAmount(value:uint):void {
			_childAmount = value;
			_game.ui.childAmount = _childAmount;}
		
		public function get ableToMove():Boolean{
			return _ableToMove;}
		
		public function set ableToMove(value:Boolean):void{
			_ableToMove = value;}
		
		public function get moveAmount():uint{
			return _moveAmount;}
		
		public function get falling():Boolean {
			return _falling;}
		
		public function set falling(value:Boolean):void {
			_falling = value;
			if (_falling){_game.moveDown(_fallAmount);}
		}
		
		public function get dead():Boolean {
			return _dead;}
			
		public function set dead(value:Boolean):void {
			_dead = value;
			if (_dead){_ableToMove = false;}else{_ableToMove = true;}
		}
		
		/*public function get globalY():int{
			return this.localToGlobal(new Point(this.x, this.y)).y;
		}*/
		
		public function hitWindow(type:String):Window {
			var _hitItem:Window;
			if (!_dead){
				for (var i = 0; i < _game.getWindowArray.length; i++){
					//More specific check done first, as
					//the first check could toss us out
					if ((type == "windowsill") &&
						(hit.hitTestObject(_game.getWindowArray[i].sill))){
						//Return the window we hit
						_hitItem = _game.getWindowArray[i];
						break;
					}else if ((type == "window") &&
						(hit.hitTestObject(_game.getWindowArray[i].windowArea))){
						//Return the window we hit
						_hitItem = _game.getWindowArray[i];
						break;
					}else if ((type == "left") &&
						(hit.hitTestObject(_game.getWindowArray[i].hitLeft))){
						//Return the window we hit
						_hitItem = _game.getWindowArray[i];
						break;
					}else if ((type == "right") &&
						(hit.hitTestObject(_game.getWindowArray[i].hitRight))){
						//Return the window we hit
						_hitItem = _game.getWindowArray[i];
						break;
					}
				}
			}
			
			return _hitItem;
		} //hitWindow
		
		public function hitSheeter():DisplayObject{
			var _hitItem:DisplayObject;
			if (!_dead){
				for (var i = 0; i < _game.sheeterArray.length; i++){
					if (hit.hitTestObject(_game.sheeterArray[i].hit)){
						//Return the sheeter we hit
						_hitItem = _game.sheeterArray[i];
						break;
					}
				}
			}
			
			return _hitItem;
		} //hitSheeter
		
		public function hitChild():Child{
			var _hitItem:Child;
			if (!_dead){
				for (var i = 0; i < _game.childArray.length; i++){
					if (hit.hitTestObject(_game.childArray[i].hit)){
						//Return the child we hit
						_hitItem = _game.childArray[i];
						break;
					}
				}
			}
			
			return _hitItem;
		} //hitChild
		
		public function hitString():SheetString {
			var _hitItem:SheetString;
			if (!_dead){
				var _masterArray:Array = _game.getStringSheetArray;
				if (_masterArray.length > 0){
					for (var j = 0; j < _masterArray.length; j++ ) {
						var _subArray:Array = _masterArray[j].getSheetArray;
						for (var k = 0; k < _subArray.length; k++ ) {
							if (hit.hitTestObject(_subArray[k])) {
								//Return the string we hit
								_hitItem = _masterArray[j];
								break;
							}
						}
					}
				}
			}
			
			return _hitItem;
		} //hitString
		
		public function hitSheet():Sheet {
			var _hitItem:Sheet;
			if (!_dead){
				var _masterArray:Array = _game.getStringSheetArray;
				if (_masterArray.length > 0){
					for (var j = 0; j < _masterArray.length; j++ ) {
						var _subArray:Array = _masterArray[j].getSheetArray;
						for (var k = 0; k < _subArray.length; k++ ) {
							if (hit.hitTestObject(_subArray[k])) {
								//Return the sheet we hit
								_hitItem = _subArray[k];
								break;
							}
						}
					}
				}
			}
			
			return _hitItem;
		} //hitSheet
		
		public function hitNanny():Nanny{
			var _hitItem:Nanny;
			if (!_dead){
				for (var i = 0; i < _game.nannyArray.length; i++){
					if (hit.hitTestObject(_game.nannyArray[i].hit)){
						//Return the nanny we hit
						_hitItem = _game.nannyArray[i];
						break;
					}
				}
			}
			
			return _hitItem;
		} //hitNanny
		
		public function hitNannyArea():Nanny{
			var _hitItem:Nanny;
			if (!_dead){
			/*	var theNanny:Nanny;
				for (var i = 0; i < _game.nannyArray.length; i++) {
					var tempNanny:Nanny = _game.nannyArray[i];
					//Height would be the bottom of a particular nanny
					var height:uint =
						tempNanny.getParentWindow.y + tempNanny.y +
							tempNanny.height;
					//If we're under a nanny and this nanny is closer
					//than the previous one...
					if (this.y > height){
						if (theNanny == null){
							theNanny = tempNanny;
						}else if (height >
							(theNanny.getParentWindow.y +
							theNanny.y +
							theNanny.height)) {
							theNanny = tempNanny;
						}
					}
				}
				
				if ((theNanny != null) &&
					(!theNanny.fired) &&
					(!theNanny.getParentWindow.covered) &&
					(theNanny.nannyHit != null)){
					if (hit.hitTestObject(theNanny.nannyHit)){
						//Return the nanny we 'hit'
						_hitItem = theNanny;
					}
				}*/
			
				for (var i = 0; i < _game.nannyArray.length; i++){
					var tempNanny:Nanny = _game.nannyArray[i];
					//Height would be the bottom of a particular nanny
					var height:uint =
						tempNanny.getParentWindow.y + tempNanny.y +
							tempNanny.height;
					//If we're under a nanny and this nanny is closer
					//than the previous one...
					if (this.y > height){
						if ((!tempNanny.fired) &&
							(!tempNanny.getParentWindow.covered) &&
							(tempNanny.nannyHit != null)){
							if (hit.hitTestObject(tempNanny.nannyHit)){
								//Return the nanny we 'hit'
								_hitItem = tempNanny;
								break;
							}
						}
					}
				}
			}
			
			return _hitItem;
		} //getNanny
		
		public function hitDroppedSheet():DroppedSheet{
			var _hitItem:DroppedSheet;
			if (!_dead){
				for (var i = 0; i < _game.droppedSheetsArray.length; i++){
					if (hit.hitTestObject(_game.droppedSheetsArray[i].hitPlayer)){
						//Return the dropped sheet that hit us
						_hitItem = _game.droppedSheetsArray[i];
						break;
					}
				}
			}
			
			return _hitItem;
		} //hitDroppedSheet
	}
}