﻿//TitleScn.as
package {
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.net.SharedObject;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	import fl.controls.CheckBox;
	public class TitleScn extends MovieClip {
		private var main:Main;
		private var _txtFmtL:TextFormat;
		private var _txtFmtR:TextFormat;
		private var _txtFmtC:TextFormat;
		private var _screen:MovieClip;
		private var _centerW:uint;
		private var _centerH:uint;
		private var _left:uint;
		private var _right:uint;
		private var _htpScn:uint;
		private var _BW:SharedObject;
		private var _htpBorder:MovieClip;
		
		public function TitleScn(value:Main, screen:String = null){
			main = value;
			_BW = main.getBW;
			_centerW = main.stage.stageWidth / 2;
			_centerH = main.stage.stageHeight / 2;
			_left = main.stage.stageWidth / 4;
			_right = main.stage.stageWidth - (_left);
			_htpScn = 0;	//Start off on the first htp screen
			
			//Create a new screen to manage things on
			_screen = new MovieClip();	addChild(_screen);
			
			//Setup text field formats
			_txtFmtL = new TextFormat();
			_txtFmtL.font = "Impact";
			_txtFmtL.size = 18;
			_txtFmtL.color = 0xFFFFFF;
			_txtFmtL.align = TextFormatAlign.LEFT;
			
			_txtFmtC = new TextFormat();
			_txtFmtC.font = "Impact";
			_txtFmtC.size = 22;
			_txtFmtC.color = 0xFFFFFF;
			_txtFmtC.align = TextFormatAlign.CENTER;
			
			_txtFmtR = new TextFormat();
			_txtFmtR.font = "Impact";
			_txtFmtR.size = 18;
			_txtFmtR.color = 0xFFFFFF;
			_txtFmtR.align = TextFormatAlign.RIGHT;
			
			switch (screen){
				case "htp":	createHTP();			break;
				case "lvl":	createLevelSelect();	break;
				default:	createStart();			break;
			}
		} //Constructor
		
		private function createStart():void {
			var _startBtn:StartBtn = new StartBtn();
			_startBtn.x = main.stage.stageWidth / 2;
			_startBtn.y = main.stage.stageHeight - main.stage.stageHeight / 4;
			_startBtn.addEventListener(MouseEvent.CLICK, clickStart, false, 0, true);
			_screen.addChild(_startBtn);
		}
		
		private function clearScreen():void {
			removeChild(_screen);		_screen = null;
			_screen = new MovieClip();	addChild(_screen);
		}
		
		public function clickStart(e:MouseEvent):void{
			clearScreen();
			!_BW.data.skip ? createHTP() : createLevelSelect();
		} //clickStart
		
		private function createHTPBorder():void{
			if (main.getGame){
				this.alpha = 0.9;
			}
			_htpBorder = new MovieClip();
			addChild(_htpBorder);
			
			var _htpTitle:TextField = new TextField();
			_htpTitle.defaultTextFormat = _txtFmtC;
			_htpTitle.text = "HOW TO PLAY:";
			_htpTitle.selectable = false;
			_htpTitle.width = 120;
			_htpTitle.x = (main.stage.stageWidth / 2) - (_htpTitle.width / 2);
			_htpTitle.y = 30;
			_htpBorder.addChild(_htpTitle);
			
			var _row:uint = main.stage.stageHeight - (main.stage.stageHeight / 3);
			var _bak:BlankBtn = new BlankBtn();	_htpBorder.addChild(_bak);
			_bak.x = _centerW - (_bak.width / 2) - _bak.width - 15; _bak.y = _row;
			_bak.buttonMode = true;	_bak.mouseChildren = false;
			_bak.name = "back";	_bak.title.text = "< Back";
			_bak.addEventListener(MouseEvent.CLICK, clickHTP, false, 0, true);
			
			var _skp:BlankBtn = new BlankBtn();	_htpBorder.addChild(_skp);
			_skp.x = _centerW - (_skp.width / 2); _skp.y = _row;
			_skp.buttonMode = true;	_skp.mouseChildren = false;
			_skp.name = "skip";	_skp.title.text = "Skip";
			_skp.addEventListener(MouseEvent.CLICK, clickHTP, false, 0, true);
			
			var _nxt:BlankBtn = new BlankBtn();	_htpBorder.addChild(_nxt);
			_nxt.x = _centerW - (_nxt.width / 2) + _nxt.width + 15; _nxt.y = _row;
			_nxt.buttonMode = true;	_nxt.mouseChildren = false;
			_nxt.name = "next";	_nxt.title.text = "Next >";
			_nxt.addEventListener(MouseEvent.CLICK, clickHTP, false, 0, true);
			
			var fullSkip:CheckBox = new CheckBox();
			fullSkip.label = "Always skip this";
			fullSkip.width = 150;
			fullSkip.x = _centerW - (fullSkip.width / 2);
			fullSkip.y = _row + 50;
			fullSkip.selected = _BW.data.skip;
			fullSkip.setStyle("textFormat", _txtFmtL);
			fullSkip.addEventListener(MouseEvent.CLICK, skipCheck, false, 0, true);
			_htpBorder.addChild(fullSkip);
		} //createHTPBorder
		
		private function skipCheck(e:MouseEvent):void{
			e.target.selected ? _BW.data.skip = true : _BW.data.skip = false;
			_BW.flush();
		}
		
		private function removeHTPBorder():void {
			removeChild(_htpBorder);
			_htpBorder = null;
			!main.getGame ? createLevelSelect() : main.removeTitle();
		} //removeHTPBorder
		
		private function createHTP():void {
			var _htpTxt1:TextField = new TextField();	_screen.addChild(_htpTxt1);
			var _htpTxt2:TextField = new TextField();	_screen.addChild(_htpTxt2);
			
			_htpTxt1.defaultTextFormat = _txtFmtL;
			_htpTxt1.selectable = false;
			_htpTxt1.wordWrap = true;
			
			_htpTxt2.defaultTextFormat = _txtFmtR;
			_htpTxt2.selectable = false;
			_htpTxt2.wordWrap = true;
			
			if(!_htpBorder){createHTPBorder();}
			
			if (_htpScn == 0){
				_htpBorder.getChildByName("back").visible = false;
			}else if (_htpScn == 3){
				_htpBorder.getChildByName("next").visible = false;
				BlankBtn(_htpBorder.getChildByName("skip")).title.text = "Done";
			}else{
				_htpBorder.getChildByName("back").visible = true;
				BlankBtn(_htpBorder.getChildByName("skip")).title.text = "Skip";
				_htpBorder.getChildByName("next").visible = true;
			}
			
			switch (_htpScn) {
				case 0:
					_htpTxt1.text = "Guide the orphan to the bottom of the orphanage";
					_htpTxt1.width = 180;
					_htpTxt1.x = _left;
					_htpTxt1.y = 90;					
					var _p:Player = new Player();		_screen.addChild(_p);
					_p.x = 400;		_p.y = 130;
					
					_htpTxt2.text = "Use W, A, S, D or the arrow keys "
						+"on your keyboard to move";
					_htpTxt2.width = 300;
					_htpTxt2.x = _right - _htpTxt2.width;
					_htpTxt2.y = 175;
					
					break;
				case 1:
					_htpTxt1.text = "You can walk on windowsills";
					_htpTxt1.width = 180;
					_htpTxt1.x = _left;
					_htpTxt1.y = 110;
					var _w1:Window = new Window();		_screen.addChild(_w1);
					_w1.x = 300;						_w1.y = 90;
					var _p1:Player = new Player();		_screen.addChild(_p1);
					_p1.x = _w1.x + (_w1.width / 2);
					_p1.y = _w1.y + _w1.sill.y;
					
					_htpTxt2.text = "Use your bedsheets to climb up and down (ADD)";
					_htpTxt2.width = 200;
					_htpTxt2.x = _right - _htpTxt2.width;
					_htpTxt2.y = 180;
					var _w2:Window = new Window();		_screen.addChild(_w2);
					_w2.x = 150;						_w2.y = 160;
					var _p2:Player = new Player();		_screen.addChild(_p2);
					_p2.x = _w2.x + (_w2.width - (_w2.width / 4));
					_p2.y = _w2.y + _w2.sill.y;
					var _s:Sheet = new Sheet();			_screen.addChild(_s);
					_s.x = _w2.x + _w2.width + 2;
					_s.y = _p2.y - _p2.height - 8;
					
					break;
				case 2:
					_htpTxt1.text = "Collect laundry baskets to get more sheets";
					_htpTxt1.width = 180;
					_htpTxt1.x = _left;
					_htpTxt1.y = 90;
					var _s4:Sheeter4 = new Sheeter4();	_screen.addChild(_s4);
					var _s6:Sheeter6 = new Sheeter6();	_screen.addChild(_s6);
					_s4.hit.visible = false;	_s4.x = 370;	_s4.y = 90;
					_s6.hit.visible = false;	_s6.x = 420;	_s6.y = 90;
					
					_htpTxt2.text = "Nannies will drop sheets on you!\nAvoid them, or "
						+"TOSS your own sheets on them!";
					_htpTxt2.width = 350;
					_htpTxt2.x = _right - _htpTxt2.width;
					_htpTxt2.y = 190;
					var _n:Nanny = new Nanny();			_screen.addChild(_n);
					_n.x = 185;		_n.y = 160;
					break;
				case 3:
					_htpTxt1.text = "Save your friends to ease your escape!";
					_htpTxt1.width = 180;
					_htpTxt1.x = _left;
					_htpTxt1.y = 110;
					var _c:Child = new Child();			_screen.addChild(_c);
					_c.hit.visible = false;		_c.x = 340;		_c.y = 120;
					
					_htpTxt2.defaultTextFormat = _txtFmtC;
					_htpTxt2.text = "Save one and get hit with a sheet from a Nanny"
						+" . . . they will take your place!";
					_htpTxt2.width = 350;
					_htpTxt2.x = _centerW - (_htpTxt2.width / 2);
					_htpTxt2.y = 180;
					
					break;
			}
		} //createHTP
		
		public function clickHTP(e:MouseEvent):void {
			//Clear the screen...
			clearScreen();
			
			switch (e.target.name){
				case "back":	_htpScn--;		break;
				case "skip":	_htpScn = 6;	break;
				case "next":	_htpScn++;		break;
			}
			_htpScn < 4 ? createHTP() : removeHTPBorder();
		} //clickStart
		
		private function createLevelSelect():void {			
			//Setup select level text
			var _sltLvlTxt:TextField = new TextField();		_screen.addChild(_sltLvlTxt);
			_sltLvlTxt.defaultTextFormat = _txtFmtC;
			_sltLvlTxt.text = "Select a Level:";
			_sltLvlTxt.selectable = false;
			_sltLvlTxt.width = 140;
			_sltLvlTxt.x = _centerW - (_sltLvlTxt.width / 2);
			_sltLvlTxt.y = (main.stage.stageHeight / 3) - (_sltLvlTxt.height / 2);
			//...and bring them to the level select menu
			//God...this is so bad...
			
			//TODO: For loop here if I'm going to be reading a dir full of XML files
			var _row:uint = main.stage.stageHeight / 3;
			var lvl1:LvlBtn = new LvlBtn(this, "Level1.xml");	_screen.addChild(lvl1);
			lvl1.x = _centerW - (lvl1.width / 2) - lvl1.width - 15;
			lvl1.y = _row;
			if (_BW.data.won.indexOf("Level1.xml") != -1){
				var complete1 = new Complete();					lvl1.addChild(complete1);
				complete1.x = lvl1.width - (complete1.width / 2);
				complete1.y = -(complete1.height / 2);
			}
			
			var lvl2:LvlBtn = new LvlBtn(this, "Level2.xml");	_screen.addChild(lvl2);
			lvl2.x = _centerW - (lvl2.width / 2);
			lvl2.y = _row;
			if (_BW.data.won.indexOf("Level2.xml") != -1){
				var complete2 = new Complete();					lvl2.addChild(complete2);
				complete2.x = lvl2.width - (complete2.width / 2);
				complete2.y = -(complete2.height / 2);
			}
			
			var lvl3:LvlBtn = new LvlBtn(this, "Level3.xml");	_screen.addChild(lvl3);
			lvl3.x = _centerW - (lvl3.width / 2) + lvl3.width + 15;
			lvl3.y = _row;
			if (_BW.data.won.indexOf("Level3.xml") != -1){
				var complete3 = new Complete();					lvl3.addChild(complete3);
				complete3.x = lvl3.width - (complete3.width / 2);
				complete3.y = -(complete3.height / 2);
			}
			
			if ((_BW.data.won.indexOf("Level1.xml") != -1) &&
			(_BW.data.won.indexOf("Level2.xml") != -1) &&
			(_BW.data.won.indexOf("Level3.xml") != -1)) {
				var _compTxt:TextField = new TextField();
				_screen.addChild(_compTxt);
				_compTxt.defaultTextFormat = _txtFmtC;
				_compTxt.text = "ALL LEVELS COMPLETE!\nCONGRATS! :-)";
				_compTxt.selectable = false;
				_compTxt.width = 190;
				_compTxt.x = _centerW - (_compTxt.width / 2);
				_compTxt.y = 210;
			}
			
			var erase:BlankBtn = new BlankBtn();	_screen.addChild(erase);
			erase.buttonMode = true;	erase.mouseChildren = false;
			erase.width = 150;
			erase.x = _centerW - (erase.width / 2);
			erase.y = 300;
			erase.title.text = "ERASE ALL DATA";
			erase.addEventListener(MouseEvent.CLICK, clickErase, false, 0, true);
		} //createLevelSelect
		
		private function clickErase(e:MouseEvent):void {
			clearScreen();
			_BW.clear();
			getMain.createData();
			createLevelSelect();
		}
		
		public function get getMain():Main {
			return main;
		}
	} //TitleScreen class
} //Package