﻿package {
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	
	public class UIManager {
		private var _game:Game;
		private var _addBtn:AddBtn;
		//private var _subBtn:SubBtn;
		private var _dropBtn:DropBtn;
		private var _numSheetsFmt:TextFormat;
		private var _lNameLbl:TextField;
		private var _numSheetsLbl:TextField;
		private var _numSheetsTxt:TextField;
		private var _numChildLbl:TextField;
		private var _numChildTxt:TextField;
		private var _warning:Warning;
		private var _wait:Timer;
		private var _levelFade:Timer;
		public function UIManager(value:Game) {
			_game = value;
			
			//Setup warning bird
			_warning = new Warning();				_game.addChild(_warning);
			_warning.x = (-1*(_warning.width/2));	_warning.y = 20;
			
			//Setup buttons
			_addBtn = new AddBtn(_game.getWorld);	_game.addChild(_addBtn);
			//_subBtn = new SubBtn(_game);			_game.addChild(_subBtn);
			_dropBtn = new DropBtn(_game);			_game.addChild(_dropBtn);
			_numSheetsFmt = new TextFormat();
				_numSheetsFmt.font = "Impact";
				_numSheetsFmt.size = 18;
				_numSheetsFmt.color = 0xFFFFFF;
			
			//Setup level name label
			_lNameLbl = new TextField();		_game.addChild(_lNameLbl);
			_lNameLbl.defaultTextFormat = _numSheetsFmt;
			_lNameLbl.selectable = false;
			_lNameLbl.width = 120;
			_lNameLbl.x = 25;					_lNameLbl.y = 25;
			_wait = new Timer(3000);
			_wait.addEventListener(TimerEvent.TIMER, startFade, false, 0, true);
			_levelFade = new Timer(180);
			_levelFade.addEventListener(TimerEvent.TIMER, fade, false, 0, true);
			
			//Number of sheets left label/text
			_numSheetsLbl = new TextField();		_game.addChild(_numSheetsLbl);
			_numSheetsLbl.defaultTextFormat = _numSheetsFmt;
			_numSheetsLbl.selectable = false;
			_numSheetsLbl.text = "Sheets left:";
			_numSheetsLbl.width = 120;
			_numSheetsLbl.x = 450;					_numSheetsLbl.y = 100;
			
			_numSheetsTxt = new TextField();		_game.addChild(_numSheetsTxt);
			_numSheetsTxt.defaultTextFormat = _numSheetsFmt;
			_numSheetsTxt.selectable = false;
			_numSheetsTxt.width = 20;
			_numSheetsTxt.x = 580;					_numSheetsTxt.y = 100;
			
			//Number of children saved label/text
			_numChildLbl = new TextField();			_game.addChild(_numChildLbl);
			_numChildLbl.defaultTextFormat = _numSheetsFmt;
			_numChildLbl.selectable = false;
			_numChildLbl.text = "Children saved:";
			_numChildLbl.width = 120;
			_numChildLbl.x = 450;					_numChildLbl.y = 120;
			
			_numChildTxt = new TextField();			_game.addChild(_numChildTxt);
			_numChildTxt.defaultTextFormat = _numSheetsFmt;
			_numChildTxt.selectable = false;
			_numChildTxt.width = 20;
			_numChildTxt.x = 580;					_numChildTxt.y = 120;
		} //Constructor
		
		private function startFade(e:TimerEvent):void {
			_wait.stop();
			_levelFade.start();
		}
		
		private function fade(e:TimerEvent):void {
			_lNameLbl.alpha -= 0.03;
			if (_lNameLbl.alpha < 0) {
				_lNameLbl.visible = false;
				_levelFade.stop();
			}
		}
		
		public function set setLevelName(value:String):void{
			_lNameLbl.text = value;
			_wait.start();
		}
		
		public function set sheetAmount(value:uint):void {
			_numSheetsTxt.text = String(value);
		}
		
		public function set childAmount(value:uint):void {
			_numChildTxt.text = String(value);
		}
		
		public function moveWarningBird():void {
			if (_game.warning){
				_warning.x += 3;
				if (_warning.x >= (_warning.stage.stageWidth + (_warning.width / 2))) {
					_game.warning = false;
					_warning.x = (-1 * (_warning.width / 2));
				}
			}
		}
		
		public function enableButtons(value:Boolean):void {
			//We can't use enabled due to the way the
			//buttons are implemented
			if (value){
				_addBtn.enabled = true;
				//_subBtn.enabled = true;
				_dropBtn.enabled = true;
			}else{
				_addBtn.enabled = false;
				//_subBtn.enabled = false;
				_dropBtn.enabled = false;
			}
		}
	} //UIManager
} //Package