﻿package{
	import flash.display.MovieClip;
	import flash.geom.Point;
	public class World extends MovieClip {
		
		private var _game:Game;
		private var _player:Player;
		
		public function World(value:Game){
			_game = value;
		} //Constructor
		
		public function addPlayer(sheetAmount:uint = 4,
			childrenAmount:uint = 0):void{
			//(game, x, y, sheet amount, children amount)
			var firstWindow:Window = _game.getWindowArray[0];
			var px:uint = firstWindow.x + (firstWindow.width / 2);
			var py:uint = firstWindow.y + firstWindow.sill.y;
			
			_player = new Player(_game, px, py, sheetAmount, childrenAmount);
			addChild(_player);
		} //addPlayer
		
		public function addSheet():void {
			//Adds a sheet to a sheet array if
			//we're not dead and have sheets
			if (_player.sheetAmount > 0 && !_player.dead) {
				var _masterArray:Array = _game.getStringSheetArray;
				var _specificString:SheetString = _player.hitString();
				var _newSheet:Sheet = new Sheet();
				//If we're hitting an array of sheets...
				if (_specificString != null) {
					//A new point is made that references the end of the last
					//sheet in the array
					var last:Sheet =
					_specificString.getSheetArray[
					_specificString.getSheetArray.length - 1];
					_newSheet.x = last.x;
					_newSheet.y = last.y + last.height - 5;
				//We didn't hit any sheets, so we're going to
				//start a new array, only if we're on a windowsill
				}else {
					var sheetX:uint;
					var direction:Boolean;
					var theWindowsill:Window =
						_player.hitWindow("windowsill");
					//If we're hitting a windowsill...
					if (theWindowsill != null) {
						//Get the window we're on
						var theWindow:Window = _player.hitWindow("window");
						//Facing left
						if ((_player.scaleX == -1) &&
							(theWindow.lString == null) &&
							(_player.hit.hitTestObject(theWindow.hitLeft))) {
							//sheetX = theWindow.x + theWindow.windowArea.x;
							sheetX = theWindow.x - 2;
							direction = false;
						//Facing right
						}else if ((_player.scaleX == 1) &&
							(theWindow.rString == null) &&
							(_player.hit.hitTestObject(theWindow.hitRight))){
							//sheetX = theWindow.x + theWindow.windowArea.x + theWindow.windowArea.width;
							sheetX = theWindow.x + theWindow.width + 2;
							direction = true;
						}else {
							//Don't place a sheet...we've already got some
							return;
						}
						_newSheet.x = sheetX;
						_newSheet.y = _player.y - _player.height - 8;
						
						//Since we didn't specify a string to attach the sheet
						//to, we need to make a new string
						var _newString:SheetString = new SheetString(this);
						_newString.name = "string" + _masterArray.length;
						_masterArray.push(_newString);
						//Set the string for the new sheet to be put onto
						_specificString = _newString;
						if (direction) {
							//Right side gets a flag
							theWindow.rString = _specificString;
						}else {
							//Left side gets a flag
							theWindow.lString = _specificString;
						}
					}else {
						//We're not on a windowsill, so do nothing
						return;
					}
				}
				
				var _stringArray:Array = _specificString.getSheetArray;
				_newSheet.name = "sheet" + _stringArray.length;
				_stringArray.push(_newSheet);
				addChildAt(_newSheet, getChildIndex(_player));
				_player.sheetAmount--;
				
				_specificString.updateTimers();
			}
		} //addSheet
		
		public function addGuideSheet():void{
			var theWindowsill:Window = _player.hitWindow("windowsill");
		} //addGuideSheet
		
		public function addWindow(type:String, wx:int, wy:int):void {
			var _window:Window = new Window(this);
			_window.x = wx;
			_window.y = wy;
			_window.name = "win" + _game.getWindowArray.length;
			_game.getWindowArray.push(_window);
			addChild(_window);
			
			switch (type){
				case "empty":
					break;
				case "sheet4":
					var _s4:Sheeter4 = new Sheeter4();
					if (!_game.SHOW_COLLBXS){
						_s4.hit.visible = false;
					}
					_s4.x = (_window.width / 2) - (_s4.width / 2);
					_s4.y = _window.sill.y - _s4.height;
					_s4.name = String("4") + "-" +
					String((_game.getWindowArray.length - 1)) + "-" +
					_game.sheeterArray.length;
					_game.sheeterArray.push(_s4);
					_window.addChild(_s4);
					break;
				case "sheet6":
					var _s6:Sheeter6 = new Sheeter6();
					if (!_game.SHOW_COLLBXS){
						_s6.hit.visible = false;
					}
					_s6.x = (_window.width / 2) - (_s6.width / 2);
					_s6.y = _window.sill.y - _s6.height;
					_window.addChild(_s6);
					_s6.name = String("6") + "-" +
					String((_game.getWindowArray.length - 1)) + "-" +
					_game.sheeterArray.length;
					_game.sheeterArray.push(_s6);
					break;
				case "child":
					var _c:Child = new Child();
					if (!_game.SHOW_COLLBXS){
						_c.hit.visible = false;
					}
					_c.x = (_window.width / 2) - (_c.width / 2);
					_c.y = _window.sill.y - _c.height;
					_window.addChild(_c);
					_c.name = String("c") + "-" +
					String((_game.getWindowArray.length - 1)) + "-" +
					_game.childArray.length;
					_game.childArray.push(_c);
					break;
				case "nanny":
					new Nanny(_window);
					break;
			}
		} //addWindow



/*********************GET/SET FUNCTIONS BELOW*********************/



		public function get getPlayer():Player{
			return _player; }
		
		public function get getGame():Game{
			return _game;}
	} //World class
} //Package